Win32 dirent: remove unused dirent.d_reclen member
[git/dscho.git] / git-sh-setup.sh
blob790e086e2f578975690b02f31d38e5b0ac7b41c8
1 #!/bin/sh
3 # This is included in commands that either have to be run from the toplevel
4 # of the repository, or with GIT_DIR environment variable properly.
5 # If the GIT_DIR does not look like the right correct git-repository,
6 # it dies.
8 # Having this variable in your environment would break scripts because
9 # you would cause "cd" to be taken to unexpected places. If you
10 # like CDPATH, define it for your interactive shell sessions without
11 # exporting it.
12 # But we protect ourselves from such a user mistake nevertheless.
13 unset CDPATH
15 # Similarly for IFS
16 unset IFS
18 git_broken_path_fix () {
19 case ":$PATH:" in
20 *:$1:*) : ok ;;
22 PATH=$(
23 SANE_TOOL_PATH="$1"
24 IFS=: path= sep=
25 set x $PATH
26 shift
27 for elem
29 case "$SANE_TOOL_PATH:$elem" in
30 (?*:/bin | ?*:/usr/bin)
31 path="$path$sep$SANE_TOOL_PATH"
32 sep=:
33 SANE_TOOL_PATH=
34 esac
35 path="$path$sep$elem"
36 sep=:
37 done
38 echo "$path"
41 esac
44 # @@BROKEN_PATH_FIX@@
46 die () {
47 die_with_status 1 "$@"
50 die_with_status () {
51 status=$1
52 shift
53 echo >&2 "$*"
54 exit "$status"
57 GIT_QUIET=
59 say () {
60 if test -z "$GIT_QUIET"
61 then
62 cat <<EOF
64 EOF
68 if test -n "$OPTIONS_SPEC"; then
69 usage() {
70 "$0" -h
71 exit 1
74 parseopt_extra=
75 [ -n "$OPTIONS_KEEPDASHDASH" ] &&
76 parseopt_extra="--keep-dashdash"
78 eval "$(
79 echo "$OPTIONS_SPEC" |
80 git rev-parse --parseopt $parseopt_extra -- "$@" ||
81 echo exit $?
83 else
84 dashless=$(basename "$0" | sed -e 's/-/ /')
85 usage() {
86 die "Usage: $dashless $USAGE"
89 if [ -z "$LONG_USAGE" ]
90 then
91 LONG_USAGE="Usage: $dashless $USAGE"
92 else
93 LONG_USAGE="Usage: $dashless $USAGE
95 $LONG_USAGE"
98 case "$1" in
99 -h)
100 echo "$LONG_USAGE"
101 exit
102 esac
105 set_reflog_action() {
106 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
107 then
108 GIT_REFLOG_ACTION="$*"
109 export GIT_REFLOG_ACTION
113 git_editor() {
114 if test -z "${GIT_EDITOR:+set}"
115 then
116 GIT_EDITOR="$(git var GIT_EDITOR)" || return $?
119 eval "$GIT_EDITOR" '"$@"'
122 git_pager() {
123 if test -t 1
124 then
125 GIT_PAGER=$(git var GIT_PAGER)
126 else
127 GIT_PAGER=cat
129 : ${LESS=-FRSX}
130 export LESS
132 eval "$GIT_PAGER" '"$@"'
135 sane_grep () {
136 GREP_OPTIONS= LC_ALL=C grep "$@"
139 sane_egrep () {
140 GREP_OPTIONS= LC_ALL=C egrep "$@"
143 is_bare_repository () {
144 git rev-parse --is-bare-repository
147 cd_to_toplevel () {
148 cdup=$(git rev-parse --show-toplevel) &&
149 cd "$cdup" || {
150 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
151 exit 1
155 require_work_tree_exists () {
156 if test "z$(git rev-parse --is-bare-repository)" != zfalse
157 then
158 die "fatal: $0 cannot be used without a working tree."
162 require_work_tree () {
163 test "$(git rev-parse --is-inside-work-tree 2>/dev/null)" = true ||
164 die "fatal: $0 cannot be used without a working tree."
167 require_clean_work_tree () {
168 git rev-parse --verify HEAD >/dev/null || exit 1
169 git update-index -q --ignore-submodules --refresh
170 err=0
172 if ! git diff-files --quiet --ignore-submodules
173 then
174 echo >&2 "Cannot $1: You have unstaged changes."
175 err=1
178 if ! git diff-index --cached --quiet --ignore-submodules HEAD --
179 then
180 if [ $err = 0 ]
181 then
182 echo >&2 "Cannot $1: Your index contains uncommitted changes."
183 else
184 echo >&2 "Additionally, your index contains uncommitted changes."
186 err=1
189 if [ $err = 1 ]
190 then
191 test -n "$2" && echo >&2 "$2"
192 exit 1
196 get_author_ident_from_commit () {
197 pick_author_script='
198 /^author /{
199 s/'\''/'\''\\'\'\''/g
201 s/^author \([^<]*\) <[^>]*> .*$/\1/
202 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
205 s/^author [^<]* <\([^>]*\)> .*$/\1/
206 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
209 s/^author [^<]* <[^>]*> \(.*\)$/@\1/
210 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
215 encoding=$(git config i18n.commitencoding || echo UTF-8)
216 git show -s --pretty=raw --encoding="$encoding" "$1" -- |
217 LANG=C LC_ALL=C sed -ne "$pick_author_script"
220 # Clear repo-local GIT_* environment variables. Useful when switching to
221 # another repository (e.g. when entering a submodule). See also the env
222 # list in git_connect()
223 clear_local_git_env() {
224 unset $(git rev-parse --local-env-vars)
228 # Platform specific tweaks to work around some commands
229 case $(uname -s) in
230 *MINGW*)
231 # Windows has its own (incompatible) sort and find
232 sort () {
233 /usr/bin/sort "$@"
235 find () {
236 /usr/bin/find "$@"
238 # Let pwd always return the uniqe real windows path
239 alias pwd='pwd -W'
240 is_absolute_path () {
241 case "$1" in
242 [/\\]* | [A-Za-z]:*)
243 return 0 ;;
244 esac
245 return 1
249 is_absolute_path () {
250 case "$1" in
252 return 0 ;;
253 esac
254 return 1
256 esac
258 # Make sure we are in a valid repository of a vintage we understand,
259 # if we require to be in a git repository.
260 if test -z "$NONGIT_OK"
261 then
262 GIT_DIR=$(git rev-parse --git-dir) || exit
263 if [ -z "$SUBDIRECTORY_OK" ]
264 then
265 test -z "$(git rev-parse --show-cdup)" || {
266 exit=$?
267 echo >&2 "You need to run this command from the toplevel of the working tree."
268 exit $exit
271 test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
272 echo >&2 "Unable to determine absolute path of git directory"
273 exit 1
275 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}